#include "mysql.h"

extern char *getSSubstr(char *string, char *sep, int no);
extern char *getSubstr(char *string, char sep, int no);
extern void browser_getDatabases(FL_OBJECT *browser);
extern void browser_getTables(FL_OBJECT *browser, char *database);
extern void choice_getDatabases(FL_OBJECT *choice);
extern void g_deactivate_object(FL_OBJECT *obj);
extern void g_activate_object(FL_OBJECT *obj);
extern int tableExist(char *database, char *table);
extern char *strupr(char *string);
extern char *strlwr(char *string);
extern int stricmp(char *str1, char *str2);
extern char *trim(char *string);
extern void choice_getTables(FL_OBJECT *choice, char *database);
extern void util_exec_sql(FL_OBJECT *browser, char *database , char *sql);
extern int util_exec_voidsql(char *database, char *sql);
extern void g_deactivate_form(FL_FORM *form);
extern void g_activate_form(FL_FORM *form);
extern char *leftTrim(char *string);
extern char *g_escapeStr(char *string);
extern MYSQL *g_mysql_connect(MYSQL *mysql,const char *host,
		     const char *user, const char *passwd);


struct setup
{
  char host[61];
  char user[15];
  char password[21];
  char datapath[128];
  char port[6];
  
  int statusRefreshTime;
  int statusMaxLines;

  int threadsRefreshTime;

  int reloadRefreshTime;
  int reloadMaxLines;
};

struct status
{
  int lignes;
};

struct statxmysqladmin
{
  char flagVersion;
  char flagStatus;
  char flagThreads;
  char threadsmode;
  char flagReload;
  char flagConfigure;
  char flagIsam;
  char flagGrant;
  char flagInputHost;
  char flagInputDb;
  char flagInputUser;
  char statusGrant;
  char flagDropdb;
  char flagCreateTable;
  char flagConnect;
  char flagDroptable;
};

struct inputGrant
{
  char host[61];
  char db[33];
  char user[17];
  char password[41];
  char select[2];
  char insert[2];
  char update[2];
  char delete[2];
  char create[2];
  char drop[2];
  char reload[2];
  char shutdown[2];
  char process[2];
  char file[2];
  char stat;
};

struct sqlcommands
{
  char *sql;
  struct sqlcommands *next;
};

struct createTable
{
  char primary;
  char qtKeys;
  char keyOn;  
  char database[33];
  char table[33];
};

struct fields
{
      int index;
      char name[33];
      int type;
      long length;
      int  decimales;
      char fdefault[512];
      char notNull;
      char zeroFill;
      char funsigned;
      char autoIncrement;
      char keyType;
      int  keySize;
      char keyName[36];
      char select;
      struct fields *prev, *next;
};

struct partkey
{
      int index;
      char nomField[33];
      int size;
      struct partkey *next;
      struct partkey *prev;
};

struct compoundkey
{
  int index;
  char nom[33];
  char type;
  struct partkey *first, *last;
  struct compoundkey *next;
  struct compoundkey *prev;
};

struct edittable
{
  struct fields *firstf, *lastf, *buff;
  struct compoundkey *firstc, *lastc, *bufc;
  struct partkey *bufp;
  FD_ccomkey *f_ccomkey;
  FD_createtable *f_createtable;
  struct createTable *ct;
  struct edittable *alter;
  char modeAlter;
  struct sqlcommands *fsql, *lsql;
};

struct browsetable
{
      struct fields *firstf, *lastf, *buff;
      struct compoundkey *firstc, *lastc, *bufc;
      struct partkey *bufp;
      struct sqlcommands *fsql, *lsql;
      FD_browsetable *browse;
      FL_FORM *fedit;
      char database[33];
      char table[33];
};
